/*
 * Bob++/bob_sens.h
 * 
 * This source include the abstract data type for the sens of optimization
 */

#include <string>


#ifndef BOBSENS_HEADER
#define BOBSENS_HEADER
namespace Bob {

/** @defgroup OptiSensGRP  Sens of optimization (Min or Max)
 *  @brief The module describes all the classes used to compare nodes according to the Optimization sens (Min and Max).
 *  You do not have to use them directly.
 *  But one of them is a type parameter for various other types.
 *  @ingroup SchedAlgoGRP
 */

/**
 * The Max class is use for Maximization.
 * @ingroup OptiSensGRP
 */

template <class Typ> 
class Max {
public :
/// Test if 2 Type variables are equals.
static bool isEq(const Typ &e1,const Typ &e2) { return e1==e2; }
/// Test if e1 is better than e2.
static bool isBetter(const Typ &e1,const Typ &e2) { return e1>e2; }
};
 
/**
 * the Min class is use for Minimization.
 * @ingroup OptiSensGRP
 */
template <class Typ>
class Min {
public :
/// Test if 2 Typ variables are equals.
static bool isEq(const Typ &e1,const Typ &e2) { return e1==e2; }
/// Test if e1 is better than e2.
static bool isBetter(const Typ &e1,const Typ &e2) { return e1<e2; }
};


};
#endif

